(function (app, $, ajaxurl) {
	function PhotosPro() {
	}

	PhotosPro.prototype.init = (function () {
		this.initHoverCaptionImage();
		this.initUploadVideo();
		this.initAttributesDialog();
	});

	PhotosPro.prototype.initHoverCaptionImage = (function () {
		$('.select-hover-caption-image').on('click', function() {
			var imageId = $(this).data('image-id'),
				mediaSelect = wp.media({
					'multiple': false,
					'library' : { type : 'image'},
				}),
				$input = $('#hover-caption-image-inp-' + imageId),
				$form =  $('#photo-editor-' + imageId);

			if(imageId) {
				mediaSelect.on('close',function(){
					var selection = mediaSelect.state().get('selection').toJSON();
					if(selection.length){
						$input.val(selection[0].url);

						$form.unbind('submit');
						$form.submit(function (event) {
							event.preventDefault();
							var $formHidden =  $('#photo-editor-hidden-' + imageId),
								$formGallery =  $('#gallery-editor-hidden'),
								data = '';
							if($formHidden.length == 1) {
								data += '&' + $formHidden.serialize();
							}
							if($formGallery.length == 1) {
								data += '&' + $formGallery.serialize();
							}
							$.post(ajaxurl, $(this).serialize() + '&_wpnonce=' + SupsysticGallery.nonce + data, function (response) {
								$.jGrowl('Information updated.'+response);
								//window.location.reload();
							});
						});
						$form.trigger('submit');
					}
				});
				mediaSelect.open();
			}
		});
	});

	PhotosPro.prototype.addAttachmentFromVideoUrl = (function(galleryId, whenSuccessAddHandler) {
		$('#sggAduErrorText').html('');
		$('#sggAduErrorText').addClass('sggAduHiden');
		SupsysticGallery.Loader.show('Please, wait until images will be imported.');

		var post = app.Ajax.Post({
			module: 'photos',
			action: 'addImageFromVideoUrl'
		});
		post.add('videoType', $('.sggDlgVideoTypeRadio[name="sggDlgVideoType"]:checked').val());
		post.add('videoUrl', $('#sggDlgUrlVideoInp').val());
		post.add('galleryId', galleryId);

		post.send(function(resp) {
			SupsysticGallery.Loader.hide();
			if(resp && resp.success) {
				$.jGrowl('Image import successfull');
				whenSuccessAddHandler();
			} else {
				if(resp.error) {
					showError(resp.error)
				} else {
					showError('Error Occurred');
				}
			}
		})
		;
		function showError(textStr) {
			$('#sggAduErrorText').html(textStr);
			$('#sggAduErrorText').removeClass('sggAduHiden');
		}
	});

	PhotosPro.prototype.initUploadVideo = (function() {
		var selfPp = this
		,	videoUrlAddDlg = $('#videoUrlAddDialog')
		,	galleryId = 0
		;
		videoUrlAddDlg.find('.sggVideoUrlAddWr').append('<div class="sggTableRow"><a target="_blank" href="https://supsystic.com/documentation/add-video-to-galleries/">How to upload SelfHosted video?</a></div>');
		videoUrlAddDlg.dialog({
			'modal':	true,
			'autoOpen':	false,
			'width':	400,
			'open': function(event, ui) {
				$('#sggDlgUrlVideoInp').val('');
				$('#sggAduErrorText').addClass('sggAduHiden');
			},
			'buttons':	{
				'Add': function() {
					galleryId = parseInt(videoUrlAddDlg.attr('data-gallery-id'));
					if(galleryId && !isNaN(galleryId)) {
						selfPp.addAttachmentFromVideoUrl(galleryId, function() {
							videoUrlAddDlg.dialog('close');
							window.location.search = 'page=supsystic-gallery&module=galleries&action=view&gallery_id='+galleryId;
						});
					}
				},
				'Cancel': function () {
					videoUrlAddDlg.dialog('close');
				},
			},
		})
		;

		$('#sggUploadVideoFromUrlBtn').on('click', function(event) {
			videoUrlAddDlg.dialog('open');
		});
	});

	PhotosPro.prototype.initAttributesDialog = function () {
		var controller = this;
        $attributesDialog = $('#ggImageAttributesDialog').dialog({
            autoOpen: false,
            modal:    true,
            width:    540,
            buttons:  {
            	Save: function () {
            		var $containers = $attributesDialog.find('select.gg-attribute-values');

            		if($containers.length > 0) {
	            		var newValues = [],
	            			imageId = $attributesDialog.attr('data-image-id'),
	            			$form = $('#photo-editor-' + imageId),
	            			attrValues;

	            		try {
	           				attrValues = JSON.parse($('#gg-attribute-values').attr('data-values'));
	            		} catch(err) { }
	            		if(!$.isArray(attrValues)) {
	                        attrValues = [];
	                    } 

	            		$containers.each(function() {
	            			var $this = $(this),
	            				value = $this.val(),
	            				$tr = $this.closest('tr'),
	            				attrName = newValue = $tr.find('input.gg-attribute-names').val(),
	            				newValue = $tr.find('input.gg-attribute-new').val();

	            			if(newValue == '') {
	            				if(value != '') {
	            					newValues.push({name: attrName, value: $this.find('option:selected').text()});
	            				}
	            			} else {
	            				newValues.push({name: attrName, value: newValue});
	            				var values = controller.getAtrributeValues(attrValues, attrName, 'values');
	            				if(values === false) {
	            					attrValues.push({name: attrName, values: [newValue]});
	            				} else if(values.indexOf(newValue) == -1) {
	            					values.push(newValue);
	            				}
	            			}
	            		});

	            		$('#gg-attribute-values').attr('data-values', JSON.stringify(attrValues));
	            		$('a.attributes-image[data-image-id="' + imageId + '"]').attr('data-values', JSON.stringify(newValues));
	            		controller.saveAttributes([{id: imageId, attributes: newValues}]);
						$form.find('[name="buttonLinkUrl"]').val($attributesDialog.find('#ggButtonLinkUrl').val());
						$form.find('[name="buttonLinkTitle"]').val($attributesDialog.find('#ggButtonLinkTitle').val());
						$form.find('[name="imageKeywords"]').val($attributesDialog.find('#ggImageKeywords').val().replace(/"/g,"'"));
						$form.trigger('submit');
						$(this).dialog('close');
	            	}

                },
                Cancel: function () {
                    $(this).dialog('close');
                }
            }
        });

        $('a.attributes-image').on('click', function(event) {
            event.preventDefault();
            var $this = $(this),
	           	imageId = $this.data('image-id'),
	           	$form = $('#photo-editor-' + imageId),
	           	$containers = $attributesDialog.find('select.gg-attribute-values');

            if($containers.length > 0) {
	           	var imgValues,
	           		attrValues;
	           	try {
	           		imgValues = JSON.parse($this.attr('data-values'));
	                attrValues = JSON.parse($('#gg-attribute-values').attr('data-values'));
	            } catch(err) { }
	            if(!$.isArray(imgValues)) {
	                imgValues = [];
	            }
	            if(!$.isArray(attrValues)) {
	                attrValues = [];
	            } 
	            $attributesDialog.attr('data-image-id', imageId);
	    		$containers.empty().each(function() {
	    			var $this = $(this),
	    				attrName = $this.closest('tr').find('input.gg-attribute-names').val(),
	    				attrValue = controller.getAtrributeValues(imgValues, attrName, 'value'),
	    				values = controller.getAtrributeValues(attrValues, attrName, 'values');

	    			$this.append($('<option value="">---</option>'));
	    			if(attrValue === false) {
	    				attrValue = '';
	    			}
	    			if(values !== false) {
	    				$.each(values, function(k, value) {
	                        $this.append($('<option value="' + k + '"' + (attrValue == value ? ' selected' : '') + '>' + value + '</option>'));
	                    });
	    			}
	    		});
	    		$attributesDialog.find('input.gg-attribute-new').val('');
	    	}
	    	$attributesDialog.find('#ggButtonLinkUrl').val($form.find('[name="buttonLinkUrl"]').val());
	    	$attributesDialog.find('#ggButtonLinkTitle').val($form.find('[name="buttonLinkTitle"]').val());
	    	$attributesDialog.find('#ggImageKeywords').val($form.find('[name="imageKeywords"]').val());
            $attributesDialog.dialog('open');
        });
    };

    PhotosPro.prototype.saveAttributes = function (attributes) {
        var post = app.Ajax.Post({
                module: 'galleries',
                action: 'saveAttributes',
            }, { gallery_id: this.galleryId });

        if(attributes.length > 0){
            post.add('attributes', attributes);
            app.Loader.show('Update image custom attributes...');

            post.send(function (response) {
                $.jGrowl('Custom attributes updated.');
                app.Loader.hide();
            });
        } else {
            $.jGrowl('Select images.');
        }
    };

    PhotosPro.prototype.getAtrributeValues = function (attributes, attrName, attrValue) {
    	if(typeof(attributes) == 'undefined' || typeof(attrName) == 'undefined' || !$.isArray(attributes)) return false;
    	for(var i = 0; i < attributes.length; i++) {
    		if('name' in attributes[i] && attrValue in attributes[i] && attributes[i]['name'] == attrName) {
    			return attributes[i][attrValue];
    		} 
    	}
    	return false;
    };

    PhotosPro.prototype.getAtrributeIndex = function (attributes, attrName) {
    	if(typeof(attributes) == 'undefined' || typeof(attrName) == 'undefined' || !$.isArray(attributes)) return false;
    	for(var i = 0; i < attributes.length; i++) {
    		if('name' in attributes[i] && attributes[i]['name'] == attrName) {
    			return i;
    		} 
    	}
    	return false;
    };

	if(app && app.Controller) {
		app.Controller.PhotosPro = function () {
			return new PhotosPro();
		}
	}

}(window.SupsysticGallery = window.SupsysticGallery || {}, jQuery, ajaxurl));

jQuery(document).ready(function () {
	SupsysticGallery.Controller.PhotosPro().init();
});

